#include <bits/stdc++.h>

using ll = long long;
using namespace std;

void solve();

signed main() {
    ll tt = 1;
    while (tt--) {
        solve();
        cout << '\n';
    }
}

const int INF = 1e9;

struct SegTree {
    int n;
    vector<int> t, add;

    SegTree(int n) {
        this->n = n;
        this->t.resize(4 * n);
        this->add.reserve(4 * n);
    }

    void emp(int v, int x) {
        t[v] += x;
        add[v] += x;
    }

    void push(int v) {
        emp(v * 2, add[v]);
        emp(v * 2 + 1, add[v]);
    }

    void build(int v, int tl, int tr, vector<int> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
    }

    int get_mn(int v, int tl, int tr, int idx) {
        if (tr - tl == 1) {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        push(v);
        if (idx < tm) {
            get_mn(v * 2, tl, tm, idx);
        } else {
            get_mn(v * 2 + 1, tm, tr, idx);
        }
    }

    void change(int v, int tl, int tr, int l, int r, int x) {
        if (r <= tl || tr <= l) {
            return;
        }
        if (l <= tl && tr <= r) {
            emp(v, x);
            return;
        }
        push(v);
        int tm = (tl + tr) / 2;
        change(v * 2, tl, tm, l, r, x);
        change(v * 2 + 1, tm, tr, l, r, x);
    }
};

struct SegTree_mx {
    int n;
    vector<int> t;

    SegTree_mx(int n) {
        this->n = n;
        this->t.resize(4 * n, -INF);
    }

    void build(int v, int tl, int tr, vector<int> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int get_mx(int v, int tl, int tr, int l, int r) {
        if (r <= tl || tr <= l) {
            return INF;
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        int tm = (r + l) / 2;
        return max(get_mx(v * 2, tl, tm, l, r), get_mx(v * 2 + 1, tm, r, tl, r));
    }
};

void solve() {
    int n;
    cin >> n;
    cout << 1;
    vector<int> h(n), k(n - 1);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> k[i];
    }
    vector<int> p;
    for (int i = 0; i < n - 1; i++) {
        p.push_back(i);
    }
    SegTree_mx tree_mx(n);
    tree_mx.build(1, 0, n, h);
    SegTree tree_mn(p.size());
    tree_mn.build(1, 0, p.size(), p);
    for (int i = 0; i < k[i]; i++) {
        int a = k[i];
        a--;
        int l = tree_mn.get_mn(1, 0, n - 1, a), r = (1, 0, n - 1, a + 2);
        r--;
        int ans = 0;
        for (int j = l; j <= r; j++) {
            ans += min(tree_mx.get_mx(1, 0, n, l, j + 1), tree_mx.get_mx(1, 0, n, j, r + 1)) - h[j];;
        }
        cout << ans << '\n';
    }
}
