#include <bits/stdc++.h>

using ll = long long;
using namespace std;

void solve();

signed main() {
    ll tt = 1;
    while (tt--) {
        solve();
        cout << '\n';
    }
}

const ll INF = 1e9;

struct SegTree {
    ll n;
    vector<ll> t, add;

    SegTree(ll n) {
        this->n = n;
        this->t.resize(4 * n);
        this->add.resize(4 * n);
    }

    void emp(ll v, ll x) {
        t[v] += x;
        add[v] += x;
    }

    void push(ll v) {
        emp(v * 2, add[v]);
        emp(v * 2 + 1, add[v]);
        add[v] = 0;
    }

    void build(ll v, ll tl, ll tr, vector<ll> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
    }

    ll get_mn(ll v, ll tl, ll tr, ll idx) {
        if (tr - tl == 1) {
            return t[v];
        }
        ll tm = (tl + tr) / 2;
        push(v);
        if (idx < tm) {
            return get_mn(v * 2, tl, tm, idx);
        } else {
            return get_mn(v * 2 + 1, tm, tr, idx);
        }
    }

    void change(ll v, ll tl, ll tr, ll l, ll r, ll x) {
        if (r <= tl || tr <= l) {
            return;
        }
        if (l <= tl && tr <= r) {
            emp(v, x);
            return;
        }
        push(v);
        ll tm = (tl + tr) / 2;
        change(v * 2, tl, tm, l, r, x);
        change(v * 2 + 1, tm, tr, l, r, x);
    }
};

struct SegTree_mx {
    ll n;
    vector<ll> t;

    SegTree_mx(ll n) {
        this->n = n;
        this->t.resize(4 * n, -INF);
    }

    void build(ll v, ll tl, ll tr, vector<ll> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    ll get_mx(ll v, ll tl, ll tr, ll l, ll r) {
        if (r <= tl || tr <= l) {
            return -INF;
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        ll tm = (tr + tl) / 2;
        return max(get_mx(v * 2, tl, tm, l, r), get_mx(v * 2 + 1, tm, tr, l, r));
    }
};

struct SegTree_ans {
    ll n;
    vector<ll> t, add;

    SegTree_ans(ll n) {
        this->n = n;
        this->t.resize(4 * n, 0);
        add.resize(4 * n, INF);
    }

    void emp(ll v, ll x, ll tl, ll tr) {
        t[v] = x * (tr - tl);
        add[v] = x;
    }

    void push(ll v, ll tl, ll tr) {
        if (add[v] != INF) {
            ll tm = (tl + tr) / 2;
            emp(v * 2, add[v], tl, tm);
            emp(v * 2 + 1, add[v], tm, tr);
            add[v] = INF;
        }
    }

    void build(ll v, ll tl, ll tr, vector<ll> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

    ll get_sm(ll v, ll tl, ll tr, ll l, ll r) {
        if (r <= tl || tr <= l) {
            return 0;
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        push(v, tl, tr);
        ll tm = (tr + tl) / 2;
        return get_sm(v * 2, tl, tm, l, r) + get_sm(v * 2 + 1, tm, tr, l, r);
    }

    void change(ll v, ll tl, ll tr, ll l, ll r, ll x) {
        if (r <= tl || tr <= l) {
            return;
        }
        if (l <= tl && tr <= r) {
            emp(v, x, tl, tr);
            return;
        }
        push(v, tl, tr);
        ll tm = (tl + tr) / 2;
        change(v * 2, tl, tm, l, r, x);
        change(v * 2 + 1, tm, tr, l, r, x);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
};

void solve() {
    ll n;
    cin >> n;
    vector<ll> h(n), k(n - 1), pref(n + 1);
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
    }
    for (ll i = 0; i < n - 1; i++) {
        cin >> k[i];
    }
    vector<ll> p;
    for (ll i = 0; i < n; i++) {
        p.push_back(i);
    }
    SegTree_mx tree_mx(n);
    tree_mx.build(1, 0, n, h);
    SegTree tree_mn(n);
    tree_mn.build(1, 0, n, p);
    SegTree_ans tree_ans(n);
    tree_ans.build(1, 0, n, h);
    for (ll i = 0; i < n - 1; i++) {
        ll a = k[i];
        a--;
        ll l1, m1, r1;
        ll l = -1, r = n;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            ll val = tree_mn.get_mn(1, 0, n, mid);
            if (val < a) {
                l = mid;
            } else {
                r = mid;
            }
        }
        l1 = l;
        l1++;
        l = -1, r = n;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            ll val = tree_mn.get_mn(1, 0, n, mid);
            if (val <= a) {
                l = mid;
            } else {
                r = mid;
            }
        }
        m1 = l;
        l = -1, r = n;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            ll val = tree_mn.get_mn(1, 0, n, mid);
            if (val <= a + 1) {
                l = mid;
            } else {
                r = mid;
            }
        }
        r1 = l;
        ll m2 = m1 + 1;
        ll val1 = -INF, val2 = -INF, ind1 = 0, ind2 = 0;
        for (int j = l1; j <= m1; j++) {
            if (val1 <= h[j]) {
                ind1 = j;
                val1 = h[j];
            }
        }
        for (int j = m2; j <= r1; j++) {
            if (val2 < h[j]) {
                ind2 = j;
                val2 = h[j];
            }
        }
        if (val1 > val2) {
            tree_ans.change(1, 0, n, ind1 + 1, ind2 + 1, val2);
        } else {
            tree_ans.change(1, 0, n, ind1, ind2, val1);
        }
        ll ans = tree_ans.get_sm(1, 0, n, l1, r1 + 1);
        ans -= pref[r1 + 1] - pref[l1];
        cout << ans << '\n';
        tree_mn.change(1, 0, n, m1 + 1, n, -1);
    }
}
