#include <bits/stdc++.h>
#define _GLIBCXX_DEBUG_ONLY()

using ll = long long;
using namespace std;

void solve();

signed main() {
    ll tt = 1;
    while (tt--) {
        solve();
        cout << '\n';
    }
}

const ll INF = 1e9;

struct SegTree {
    ll n;
    vector<ll> t, add;

    SegTree(ll n) {
        this->n = n;
        this->t.resize(4 * n);
        this->add.resize(4 * n);
    }

    void emp(ll v, ll x) {
        t[v] += x;
        add[v] += x;
    }

    void push(ll v) {
        emp(v * 2, add[v]);
        emp(v * 2 + 1, add[v]);
        add[v] = 0;
    }

    void build(ll v, ll tl, ll tr, vector<ll> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
    }

    ll get_mn(ll v, ll tl, ll tr, ll idx) {
        if (tr - tl == 1) {
            return t[v];
        }
        ll tm = (tl + tr) / 2;
        push(v);
        if (idx < tm) {
            get_mn(v * 2, tl, tm, idx);
        } else {
            get_mn(v * 2 + 1, tm, tr, idx);
        }
    }

    void change(ll v, ll tl, ll tr, ll l, ll r, ll x) {
        if (r <= tl || tr <= l) {
            return;
        }
        if (l <= tl && tr <= r) {
            emp(v, x);
            return;
        }
        push(v);
        ll tm = (tl + tr) / 2;
        change(v * 2, tl, tm, l, r, x);
        change(v * 2 + 1, tm, tr, l, r, x);
    }
};

struct SegTree_mx {
    ll n;
    vector<ll> t;

    SegTree_mx(ll n) {
        this->n = n;
        this->t.resize(4 * n, -INF);
    }

    void build(ll v, ll tl, ll tr, vector<ll> &arr) {
        if (tr - tl == 1) {
            t[v] = arr[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(v * 2, tl, tm, arr);
        build(v * 2 + 1, tm, tr, arr);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    ll get_mx(ll v, ll tl, ll tr, ll l, ll r) {
        if (r <= tl || tr <= l) {
            return -INF;
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        ll tm = (tr + tl) / 2;
        return max(get_mx(v * 2, tl, tm, l, r), get_mx(v * 2 + 1, tm, tr, l, r));
    }
};

void solve() {
    ll n;
    cin >> n;
    vector<ll> h(n), k(n - 1);
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (ll i = 0; i < n - 1; i++) {
        cin >> k[i];
    }
    vector<ll> p;
    for (ll i = 0; i < n; i++) {
        p.push_back(i);
    }
    SegTree_mx tree_mx(n);
    tree_mx.build(1, 0, n, h);
    SegTree tree_mn(n);
    tree_mn.build(1, 0, n, p);
    for (ll i = 0; i < n - 1; i++) {
        ll a = k[i];
        a--;
        ll l1, m1, r1;
        ll l = -1, r = n;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            ll val = tree_mn.get_mn(1, 0, n, mid);
            if (val < a) {
                l = mid;
            } else {
                r = mid;
            }
        }
        l1 = l;
        l1++;
        l = -1, r = n;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            ll val = tree_mn.get_mn(1, 0, n, mid);
            if (val <= a) {
                l = mid;
            } else {
                r = mid;
            }
        }
        m1 = l;
        l = -1, r = n;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            ll val = tree_mn.get_mn(1, 0, n, mid);
            if (val <= a + 1) {
                l = mid;
            } else {
                r = mid;
            }
        }
        r1 = l;
        ll ans = 0;
        for (ll j = max(0ll, l1); j <= min(n - 1, r1); j++) {
            ans += min(tree_mx.get_mx(1, 0, n, l1, j + 1), tree_mx.get_mx(1, 0, n, j, r1 + 1)) - h[j];
        }
        tree_mn.change(1, 0, n, min(m1 + 1, n - 1), n, -1);
        cout << ans << '\n';
    }
}
